#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <dos.h>
#include <string.h>
#include <ctype.h>

int			Converter [ 8 ] = { 0 , 4 , 2 , 6 , 1 , 5 , 3 , 7 } ;
int			Clear = 0 , SmartSpace = 0 , Monochrome = 0 , ShowPicture = 0 ;
char			InFile [ 128 ] ;
char			OutFile [ 128 ] ;
char			Temp [ 40 ] ;
int			I , J , X , Y , Fore , Back , Char , Attr , ExtStartsAt ;
FILE			* In ;
FILE			* Out ;
char			Image [ 3850 ] ;
int			LastAttr = - 1 , NextLine = 0 , Zapping = 0 , Spaces , Black = 0 ;
union REGS	r ;


void main ( int argc , char * argv [] )
{
	cprintf ( "SCR2ANSI (C) J Whitham 1994\n\n" ) ;
	if ( argc < 2 )
	{
		printf ( "Parameters expected:\n\n"
				"    SCR2ANSI infile options\n\n"
				"infile - SCR file\n"
				"options - C clearscreen\n"
				"          D smart spacing\n"
				"          G greyscale only\n"
				"          S show picture\n"
				"          R use CRLF to go to next line\n"
				"          L use LF to go to next line\n"
				"          E use escape seq to go to next line\n"
				"          B always set background to black\n"
				"          Z delete each line before drawing on it\n"
				"\n\nNote: smart spacing does not work well on a screen\n"
				"with a background of any colour but black.\n" ) ;
		exit ( 0 ) ;
	}
	strcpy ( InFile , argv [ 1 ] ) ;
	if ( argc > 2 )
	{
		for ( I = 2 ; I < argc ; I ++ )
		{
			for ( J = 0 ; J < strlen ( argv [ I ] ) ; J ++ )
			{
				switch ( toupper ( argv [ I ][ J ] ) )
				{
					case 'C' :	Clear = 1 ;
									break ;
					case 'D' :	SmartSpace = 1 ;
									break ;
					case 'G' :	Monochrome = 1 ;
									break ;
					case 'S' :	ShowPicture = 1 ;
									break ;
					case 'B' :	Black = 1 ;
									break ;
					case 'R' :	NextLine = 0 ;
									break ;
					case 'L' :	NextLine = 1 ;
									break ;
					case 'E' :	NextLine = 2 ;
									Clear = 1 ;
									break ;
					case 'Z' :	Zapping = 1 ;
									break ;
				}
			}
		}
	}
	strupr ( InFile ) ;
	strcpy ( OutFile , InFile ) ;
	ExtStartsAt = -1 ;
	for ( I = strlen ( InFile ) -1 ; I >= 0 ; I -- )
	{
		if ( InFile [ I ] == '\\'
		|| InFile [ I ] == '/'
		|| InFile [ I ] == ':' )
		{
			break ;
		}
		if ( InFile [ I ] == '.' )
		{
			ExtStartsAt = I ;
		}
	}
	if ( ExtStartsAt == -1 )
	{
		strcat ( InFile , ".SCR" ) ;
	} else {
		OutFile [ ExtStartsAt ] = '\0' ;
	}
	strcat ( OutFile , ".ANS" ) ;
	printf ( "Converting %s to %s\n" , InFile , OutFile ) ;
	In = fopen ( InFile , "rb" ) ;
	Out = fopen ( OutFile , "wb" ) ;
	if ( In == NULL )
	{
		printf ( "\nCouldn't open %s\n" , InFile ) ;
		exit ( 0 ) ;
	}
	if ( Out == NULL )
	{
		printf ( "\nCouldn't open %s\n" , OutFile ) ;
		exit ( 0 ) ;
	}
	fread ( Image , 7 , 1 , In ) ;
	if ( fread ( Image , 3840 , 1 , In ) != 1 )
	{
		fcloseall () ;
		printf ( "\n%s is not a SCR file\n" , InFile ) ;
		exit ( 0 ) ;
	}
	fclose ( In ) ;
	if ( Clear )
	{
		fwrite ( "[2J" , 4 , 1 , Out ) ;
	}
	if ( ShowPicture )
	{
		r . x . ax = 0x0f00 ;
		int86 ( 0x10 , & r , & r ) ;
		if ( r . h . al > 3 )
		{
			printf ( "\nError: showing the picture requires CGA.\n" ) ;
			fclose ( Out ) ;
			exit ( 0 ) ;
		}
		r . x . ax = 3 ;
		int86 ( 0x10 , & r , & r ) ;
	}
	for ( Y = 0 ; Y < 24 ; Y ++ )
	{
		if ( ! Clear && Zapping )
		{
			fwrite ( "[K" , 3 , 1 , Out ) ;
		}
		Spaces = 0 ;
		for ( X = 0 ; X < 80 ; X ++ )
		{
			Char = Image [ (( X + ( Y * 80 ) ) * 2 ) + 0 ] ;
			Attr = Image [ (( X + ( Y * 80 ) ) * 2 ) + 1 ] & 127 ;
			if ( Black )
			{
				Attr = Attr & 15 ;
			}
			if ( ShowPicture )
			{
				_fmemset ( MK_FP ( 0xb800 , (( X + ( Y * 80 ) ) * 2 ) + 0 ) , Char , 1 ) ;
				_fmemset ( MK_FP ( 0xb800 , (( X + ( Y * 80 ) ) * 2 ) + 1 ) , Attr , 1 ) ;
			}
			if ( Attr != LastAttr )
			{
				Fore = Converter [ Attr % 8 ] + 30 ;
				Back = Converter [ ( Attr / 16 ) % 8 ] + 40 ;
				if ( Monochrome )
				{
					if ( Fore > 30 )
					{
						Fore = 37 ;
					}
					if ( Back > 40 )
					{
						Back = 47 ;
					}
				}
				sprintf ( Temp , "[%d;%d;%dm" , ( Attr % 16 ) / 8 ,
									Fore , Back ) ;
				fwrite ( Temp , strlen ( Temp ) , 1 , Out ) ;
				LastAttr = Attr ;
			}
			if ( SmartSpace )
			{
				if ( Char == 32 || Char == 0 || Char == 255 )
				{
					Spaces ++ ;
				} else {
					if ( Spaces > 0 )
					{
						if ( Spaces > 4 )
						{
							sprintf ( Temp , "[%dC" , Spaces ) ;
							fwrite ( Temp , strlen ( Temp ) , 1 , Out ) ;
						} else {
							for ( I = 0 ; I < Spaces ; I ++ )
							{
								fwrite ( " " , 1 , 1 , Out ) ;
							}
						}
						Spaces = 0 ;
					}
					fwrite ( & Char , 1 , 1 , Out ) ;
				}
			} else {
				if ( Char == 0 || Char == 255 )
				{
					Char = 32 ;
				}
				fwrite ( & Char , 1 , 1 , Out ) ;
			}
		}
		if ( NextLine < 2 )
		{
			if ( NextLine == 0 )
			{
				strcpy ( Temp , "\x0a\x0d" ) ;
			} else {
				strcpy ( Temp , "\x0d" ) ;
			}
			fwrite ( Temp , strlen ( Temp ) , 1 , Out ) ;
		} else {
			sprintf ( Temp , "[%d;0H" , Y ) ;
			fwrite ( Temp , strlen ( Temp ) , 1 , Out ) ;
		}
	}
	fwrite ( "[0;37;40m\x0a\x0d" , 12 , 1 , Out ) ;
	fclose ( Out ) ;
	if ( ShowPicture )
	{
		r . x . ax = 0x0200 ;
		r . x . bx = 0 ;
		r . x . dx = 0x1800 ;
		int86 ( 0x10 , & r , & r ) ;
		cprintf ( "Press any key.." ) ;
		r . x . ax = 0 ;
		int86 ( 0x16 , & r , & r ) ;
		r . x . ax = 3 ;
		int86 ( 0x10 , & r , & r ) ;
	}
	printf ( "\nConversion complete.\n" ) ;
	exit ( 1 ) ;
}

			
			


